<?php
// +-----------------------------------------------------------------------+
// | PhpWebGallery - a PHP based picture gallery                           |
// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

// All customization could be done:
// - in wall_conf.inc.php  (Main parms are in this generated file)
// And, under control of your partner (he could to prepare them for you):
// + in $wall['margin_top'] $wall['margin_left'] php variables here below 
// + in the html_header function here below
// + in the text_title function here below
// That's all ! Enjoy !

// Attention : Don't forget that wall use absolute positioning !!!
  $wall['margin_top']  = 0; /* shift down your wall in px only */
  $wall['margin_left'] = 0; /* shift right your wall */
  $wall['align'] = 'center'; /* left / right are possible values */

// Can be customized 
// echo html text (<html><head><title><meta><link> ...)
// and return all unclosed tags (</div></body></html>
// If you decide to include wall.php in another page much of this code can
// be reduced to a minimal list
function wall_html_header()
{ 
  global $wall;
  list($tpl, $t, $thm) = explode('/', $_SESSION['yoga/theme/clear']);
  $layout = $wall['gallery'] . 'template/' . $tpl . '/layout.css';
  $colors = $wall['gallery'] . 'template/' . $tpl . '/default-colors.css';
  $theme = $wall['gallery'] . 'template/' . $_SESSION['yoga/theme/clear'] 
	      . '/theme.css';

// Can be certainly and mainly cleared 
// ie. if this wall is embed in another web page 
// Think about what append on css in such case
// Analyze how refresh statement can be included in the other page
// Notice : generator is protected against some Edit software
  echo
'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="fr" dir="ltr">
<head>
<title>' . $wall['title'] . '</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<met' . 'a name="g' . 'enerator" content="PhpWebGallery (aka PWG), see www.phpwebgallery.net">
<meta name="description" content="PhpWebGallery - more on www.phpwebgallery.net">
<meta http-equiv="expires" content="never">
<meta name="robots" content="index, follow">
<meta name="revisit-after" content="15 days">
<meta name="keywords" content="gallery, picture, category, categories, 
  slideshow, tags, search, plugin, menu, description, exif, iptc, rating, 
	comment, material, php, mysql, css, recent, favorite, member, web service, 
	history, notification, rss, video, photos, forum, gpl, phpwebgallery">
<meta name="author" content="PhpWebGallery team">
<meta name="copyright" content="PhpWebGallery team members">
<meta http-equiv="Page-Enter" content="blendTrans(Duration=0.8)">
<meta http-equiv="refresh" content="' . $wall['refresh'] . ';url=wall.php">
<link rel="stylesheet" type="text/css" href="' . $layout . '">
<link rel="stylesheet" type="text/css" href="' . $colors . '">
<link rel="stylesheet" type="text/css" href="' . $theme . '">
';

// Recommended statement if possible <link rel="prefetch" href=...
// prefetch function could be call separately and you can find it below
  wall_prefetch();

// others <head> statements
// Analyze each of them if you want to integrate wall.php in another page
echo '<style type="text/css"> 
img.wthumb { border: 0; width: ' . $wall['utw'] . 'px; height: ' 
  . $wall['uth'] . 'px; }
img.High { border: 0; width: ' . ($wall['utw'] * 3). 'px; height: ' 
  . ($wall['uth'] * 3) . 'px; }
#wall { width:' . $wall['columns'] * $wall['utw'] . 'px; margin: 0px auto;
  border: 0px; padding: 0px; 
  text-align:' . $wall['align'] . '; display:block; position:relative; }
</style>
</head>

<body>
<div>
  <!-- Before the Wall -->
  <div id="wall">';

  // Closing tags sequence must be return for a later echo
  return '
	</div>
	<div style="margin: auto; border: 0px; padding: 0px; text-align:center; 
         display:block; position: absolute; right: 25px; bottom: 5px; 
		 font-size: 0.7em;">
	  <a href="./wall.php?reset">Rebuild current wall.</a> <br />
	  <div id="copyright">
        <a name="EoP"></a> <!-- End of Page -->

        <!-- Please, do not remove this copyright. If you really want to,
             contact us on http://phpwebgallery.net to find a solution on how
             to show the origin of the script...-->

        Powered by <a href="http://www.phpwebgallery.net" 
		class="PWG"><span class="P">Php</span><span class="W">Web</span><span class="G">Gallery</span></a>
  
      </div>
	</div>
	<!-- End of the Wall -->
</div>
</body>
</html>';
}

// Can be customized 
// This is the text you can read above the wall
function wall_text_title($color='#fff;', $shift=0)
{
	/* Recommended Offsets, thumbnail sizes, and other parms */
  global $wall; 
  /* Over the 3x3 pic and 20% of thumb width */
  $x = (int) ( $wall['posX'] + ( $wall['utw'] * 0.2 )); 
  /* Over the 3x3 pic and 150% of thumb height */ 
  $y = (int) $wall['posY'] + ($wall['uth'] * 1.5);     
  $x += $shift;
  $y += $shift;
  
  // text_title is a simple php function 
  // text_title is a sample and you can change it following your needs
  // eg. Language access (Welcome / Bienvenue) or any.
  // ------ Begin of customization
  $txt  = "\n" 
	      . '  <!-- Text Title ' . " --> \n"
        . '  <div style="position: absolute;'
          . ' text-align: left; padding: 0px; margin: 0px;'
          . ' line-height: 3.3em; font-size: 2.7em; color: ' . $color 
				  . ' left:' . $x . 'px; top: ' . $y . 'px;">' . "\n"
        . '    <a href="' . $wall['gallery'] 
				  . '" style="text-decoration: none; color: ' . $color . ';">'
          . $wall['title'] . "</a> \n"
				. "  </div>\n";
  // ------ End of customization
  return $txt;
}

// Should normaly not customized but prefetch function
// can be moved to another module if needed (take care about session)

// Prefetch thumbnails as much as we have (will be better for next run) 
// (Notice: redondant href in case of lack of available thumbnails)
// this function redo "unserialize" 'cause it maybe called by an external code
// If you get warning messages from the server about max open file
// the reduce it here
function wall_prefetch($maxopen=100)
{
  // Notice that no global statement is required in this function
  if (isset($_SESSION['memory'])) {
    $wall['thumbc'] = unserialize($_SESSION['memory']);
    for ( $i=0; $i<min($wall['thumbc']['result']['images']['count'],$maxopen);
	      $i++) {
      $picture = $wall['thumbc']['result']['images']['_content'][$i];
      echo '  <link rel="prefetch" href="'.$picture['tn_url'].'">'."\n";
    }
  }
}


//    / \
//   / | \
//  /____\    No change will be done usually beyond this point !!!  

/* Found a curious specific error: which implies a specific ErrorHandler
   Notice that module Unknown can't be modified on line 0
   Case Primary site (OVH: Hoster) / Requester site (Free: French provider)
   
Warning: Unknown: Your script possibly relies on a session side-effect which existed until PHP 4.2.3. 
Please be advised that the session extension does not consider global variables as a source of data, 
unless register_globals is enabled. You can disable this functionality and this warning by setting 
session.bug_compat_42 or session.bug_compat_warn to off, respectively. in Unknown on line 0
*/
// ini_set('session.bug_compat_42', 'off');
// ini_set('session.bug_compat_warn', 'off');
//     But nothing changed so...
function wallErrorHandler($errno, $errstr, $errfile, $errline)
{
    switch ($errno) {
    case E_USER_ERROR:
        return false;
        break;

    case E_USER_WARNING:
        return true;
        break;

    case E_USER_NOTICE:
        return false;
        break;

    default:
        return true;
        break;
    }
}
// Error Handler Configuration 
$old_error_handler = set_error_handler("wallErrorHandler");

// Official parameters
@include_once('./wall_conf.inc.php');
if (!isset($wall['server'])) {
  exit('Wall is not available.');
}

// Build the wall
@session_start();

// Calculated parms
  /* Displayed thumbnails count */
$wall['Displayed_TN'] = $wall['lines']*$wall['columns']; 
  /* Resquested thumbnails count */
$wall['Requested_TN'] = (int)($wall['Displayed_TN']*15/10);             
  /* Uniform thumbnail height */
$wall['uth'] = $wall['thumb_height'];  
  /* Uniform thumbnail width */         
$wall['utw'] = (int) ($wall['uth']*(($wall['image_ratio_min']
     + $wall['image_ratio_max'])/2));  
	 
if (isset($wall['large']) and $wall['large'] == 'Yes') { 
  $wall['Inc_3x3'] = true; 
}
else { $wall['Inc_3x3'] = false; }

// At least 4 thumbnails large and 4 thumbnails high for a large picture  
$wall['Inc_3x3'] = ( $wall['columns'] < 4 or $wall['lines']  < 4 ) ? 
                   false : $wall['Inc_3x3'];

// New session or some changed parms (larger wall)
if ((!isset($_SESSION['seq'])) 
    or (count($_SESSION['seq']) < $wall['Displayed_TN'])
    or isset($_GET['reset']) ) {
  $service = curl_init();
  curl_setopt($service, CURLOPT_URL,$wall['server'].$wall['Requested_TN']);
  curl_setopt($service, CURLOPT_HEADER, 0);
  curl_setopt($service, CURLOPT_RETURNTRANSFER, true);
  $response = curl_exec($service);
  curl_close($service);

  $_SESSION['memory'] = $response;                      /* Picture set */
  $_SESSION['oldest'] = 0;                   /* Assumed oldest picture */
  $temp = range(0,$wall['Displayed_TN']-1);
  shuffle($temp);                                   /* Change sequence */
  $_SESSION['seq'] = $temp;
  
  $partner = $wall['partner'];
  $partner = ($partner == '') ? '': '&partner=' . $partner ;
  $service = curl_init();
  $req = $wall['gallery'] . 'ws.php?method=pwg.session.getStatus&format=php'
         . $partner;

  // pwg.session.getStatus is a free partner service (partner not requested)
  curl_setopt($service, CURLOPT_URL, $req);
  curl_setopt($service, CURLOPT_HEADER, 0);
  curl_setopt($service, CURLOPT_RETURNTRANSFER, true);
  $response = curl_exec($service); 
  curl_close($service);

  $theme = unserialize($response);
  $template = (isset($theme['result']['theme'])) ?
	      $theme['result']['template'] . '/theme/' . $theme['result']['theme']
	      : 'yoga/theme/clear';
  $_SESSION['yoga/theme/clear'] = $template;       /* Default template */ 
}

// Current thumbnail set is $wall['thumbc']
$wall['thumbc'] = unserialize($_SESSION['memory']);
if ($wall['thumbc']['stat']!=='ok' 
   or $wall['thumbc']['result']['images']['count'] < 3) {
  session_unset();
  session_destroy();
  $_SESSION = array();
  exit('Wall is not available. Please contact your partner or try to'
	 . '<a href="./wall.php?reset">restart</a> current process.');
}

// Which picture has to be replaced (the oldest one) 
$ptr = $_SESSION['oldest'];
$zap = $_SESSION['seq'][$ptr];

$switch_large = in_array($ptr, 
       range(0,$wall['Requested_TN']-1, max($wall['lines'],$wall['columns'])));
$ptr++; 
$_SESSION['oldest'] = $ptr % ($wall['Displayed_TN']-1);

// Which picture will be the replacer (the next one in the above displayed list
$available = $wall['thumbc']['result']['images']['count']; 
$start = ($available > $wall['Displayed_TN']) ? 
          $wall['Displayed_TN'] : max($wall['lines'],$wall['columns']);
$modulo =  ($available > $wall['Displayed_TN']) ? 
          $available-$wall['Displayed_TN'] 
          : ($wall['Displayed_TN'] - max($wall['lines'],$wall['columns']));
$modulo--;
$rep = $start + ($ptr % $modulo);

// Repeat thumbnails if available count is less than needed
// Then thumbnails will be repeated on the client screen
// But how to do in another way 'cause we don't have enough thumbnails
if ($available <= $wall['Displayed_TN']) {
  $mgr = $wall['thumbc']['result']['images']['_content'];
	for ( ;
	   count($wall['thumbc']['result']['images']['_content'])
	    < $wall['Requested_TN']; ) 
	{
	  $wall['thumbc']['result']['images']['_content'] = 
		  array_merge ( $wall['thumbc']['result']['images']['_content'], $mgr );
	}
	// Now, update thumbnails count (for next run)
	$wall['thumbc']['result']['images']['count'] = 
	  count($wall['thumbc']['result']['images']['_content']);
}

// Swap pictures (The oldest will be enlarged)
$old = $wall['thumbc']['result']['images']['_content'][$zap];
//  var_dump($old['element_url']);
$wall['thumbc']['result']['images']['_content'][$zap] = 
  $wall['thumbc']['result']['images']['_content'][$rep];
$wall['thumbc']['result']['images']['_content'][$rep] = $old;

// Replacement (for next run)
$_SESSION['memory'] = serialize($wall['thumbc']);

// Must we display a new large picture?
if ( $switch_large ) {
  // The displayed picture will the removed one
  $_SESSION['old_picture'] = $old;
  $wall['posX'] = rand(0, $wall['columns']-3);
  $wall['posY'] = rand(0, $wall['lines']-3);
  $wall['posX'] = $wall['posX']*$wall['utw'];
  $wall['posY'] = $wall['posY']*$wall['uth'];
  $_SESSION['large_posX'] = $wall['posX'];
  $_SESSION['large_posY'] = $wall['posY'];
}
$wall['posX'] = $wall['margin_left'] + $_SESSION['large_posX'];
$wall['posY'] = $wall['margin_top'] + $_SESSION['large_posY'];
$old  = $_SESSION['old_picture'];

// Which thumbnails don't have to be displayed
if ($wall['Inc_3x3']) {
  $blindX = array( $wall['posX'], $wall['posX']+$wall['utw'], 
            $wall['posX']+$wall['utw']+$wall['utw'] );
  $blindY = array( $wall['posY'], $wall['posY']+$wall['uth'], 
            $wall['posY']+$wall['uth']+$wall['uth'] );
}
else {
  $blindX = array();
  $blindY = array();
}  

// HTML Code Generation
$end_code = wall_html_header();

// Thumbnails => Link to their related picture page
$HTML_txt = wall_thumbnails($wall['thumbc']); 
  
if ($wall['Inc_3x3']) {
  // Large Picture (3x3 thumbnails) => Link to gallery main page
  $HTML_txt .= wall_large_picture();
}
  
// Text title => Link to where you decided in text_title at the begining
if (isset($wall['title']) and $wall['title']!=='') {
  $HTML_txt .= wall_text_title('#000;',2); /* text-shadow till CSS3 support */
  $HTML_txt .= wall_text_title();
}
echo $HTML_txt; /* Send the code */

// Send unclosed tags
echo $end_code;

// Script End - Following functions are called above


// Code for thumbnails 
function wall_thumbnails()
{
  global $wall, $blindX, $blindY;
  $txt = '';
  for ($i=0;$i<$wall['Displayed_TN'];$i++) {
    $x = ($i % $wall['columns'])*$wall['utw'];
    $y = ((int) ($i / $wall['columns']))*$wall['uth'];
    $x += $wall['margin_left'];
    $y += $wall['margin_top'];
    // Masked thumbnails by larger picture ?
    if (in_array($x,$blindX) and in_array($y,$blindY)) { continue; }
  
    $picture = $wall['thumbc']['result']['images']['_content'][$i];
    $txt .= "\n" . '  <!-- ' . $_SESSION['seq'][$i] . '.' 
         . $picture['id'] . " --> \n "; 
    $txt .= '<div style="position: absolute; left:' 
         . $x . 'px; top: ' . $y . 'px;">' . "\n";
    $alt = ($picture['name']=='') ? 
            $wall['default_alt'] : 
            htmlspecialchars($picture['name'], ENT_QUOTES); 
    $title = ($picture['comment']=='') ? 
              $wall['default_alt'] : 
              htmlspecialchars($picture['comment'], ENT_QUOTES);
    $title = '[' . $picture['id'] . '] ' . ' - ' . $title;           
    $txt .= '  <a href="' . $wall['gallery']
         . 'picture.php?' . $picture['id'] 
         . '">' . "\n" 
         . '  <img src="' . $picture['tn_url']
         . '" title="' . $title . '"  alt="' . $alt 
         . '" class="wthumb"></a>';
    $txt .= " \n</div>\n"; 
  }
  return $txt;
}

// Code for large picture (3x3 thumbnails) 
function wall_large_picture()
{
  global $wall,$old;
  // Larger Picture => Link to gallery
  $txt = "\n" . '  <!-- Large picture ' . " --> \n ";
  $txt .= '<div style="position: absolute; left:' 
       . $wall['posX'] . 'px; top: ' . $wall['posY'] . 'px;">' . "\n";
  $picture = $old;
  $alt = ($picture['name']=='') ? 
          $wall['default_alt'] : 
          htmlspecialchars($picture['name'], ENT_QUOTES); 
  $title = ($picture['comment']=='') ? 
            $wall['default_alt'] : 
            htmlspecialchars($picture['comment'], ENT_QUOTES); 
  $txt .= '  <a href="' . $wall['gallery'] 
       . '">' . "\n" 
       . '<img src="' . $picture['element_url']
       . '" title="' . $title . '"  alt="' . $alt
	   . '" class="High"></a>';
  $txt .= "\n</div>\n";
  return $txt;
}
?>